<template>
  <div class="row m-0 vh-100 justify-content-center align-items-center">
    <div class="col-auto p-5">
      <div class="card">
        <h3 class="card-header text-center">Heroes App</h3>
        <div class="card-body">
          <p v-if="errorMessage" class="text-danger">{{errorMessage}}</p>
          <form @submit.prevent="procesar" autocomplete="off">
            <div class="mb-3">
              <div class="input-group">
                <input type="text" class="form-control" :class="{'is-valid': !$v.nombre.$invalid, 'is-invalid': $v.nombre.$invalid}" placeholder="Nombre completo" v-model="$v.nombre.$model" @keypress="limpiarErrores('name')">
                <div class="input-group-append">
                  <div class="input-group-text">
                    <span class="fas fa-user"></span>
                  </div>
                </div>
              </div>
              <div class="text-danger" v-if="!$v.nombre.required">
                El campo es requerido.
              </div>
              <div class="text-danger" v-for="(errorNombre, index) in errors.name" :key="index">
                {{ errorNombre }}
              </div>
            </div>
            <div class="mb-3">
              <div class="input-group">
                <input type="email" class="form-control" :class="{'is-valid': !$v.email.$invalid, 'is-invalid': $v.email.$invalid}" placeholder="Correo electrónico" v-model="$v.email.$model" @keypress="limpiarErrores('email')">
                <div class="input-group-append">
                  <div class="input-group-text">
                    <span class="fas fa-envelope"></span>
                  </div>
                </div>
              </div>
              <div class="text-danger" v-if="!$v.email.required">
                El campo es requerido.
              </div>
              <div class="text-danger" v-if="!$v.email.email">
                El campo debe ser una dirección de correo válida.
              </div>
              <div class="text-danger" v-for="(errorEmail, index) in errors.email" :key="index">
                {{ errorEmail }}
              </div>
            </div>
            <div class="mb-3">
              <div class="input-group">
                <input type="password" class="form-control" :class="{'is-valid': !$v.password.$invalid, 'is-invalid': $v.password.$invalid}" placeholder="Contraseña" v-model="$v.password.$model" @keypress="limpiarErrores('password')">
                <div class="input-group-append">
                  <div class="input-group-text">
                    <span class="fas fa-lock"></span>
                  </div>
                </div>
              </div>
              <div class="text-danger" v-if="!$v.password.required">
                El campo es requerido.
              </div>
              <div class="text-danger" v-if="!$v.password.minLength">
                Debe ser de al menos {{$v.password.$params.minLength.min}} caracteres
              </div>
              <div class="text-danger" v-if="!$v.password.maxLength">
                Debe ser menor de {{$v.password.$params.maxLength.max}} caracteres
              </div>
              <div class="text-danger" v-for="(errorPass, index) in errors.password" :key="index">
                {{ errorPass }}
              </div>
            </div>
            <div class="mb-3">
              <div class="input-group">
                <input type="password" class="form-control" :class="{'is-valid': !$v.passwordConfirm.$invalid, 'is-invalid': $v.passwordConfirm.$invalid}" placeholder="Repetir contraseña" v-model="$v.passwordConfirm.$model" @keypress="limpiarErrores('password_confirmation')">
                <div class="input-group-append">
                  <div class="input-group-text">
                    <span class="fas fa-lock"></span>
                  </div>
                </div>
              </div>
              <div class="text-danger" v-if="!$v.passwordConfirm.sameAs">
                Las contraseñas no coinciden
              </div>
              <div class="text-danger" v-for="(errorPassCon, index) in errors.password_confirmation" :key="index">
                {{ errorPassCon }}
              </div>
            </div>
            <button type="submit" :disabled="$v.$invalid || loading" class="btn btn-block btn-primary"><i class="fas" :class="{'fa-sign-in-alt': !loading, 'fa-spinner fa-pulse': loading}"></i> Submit</button>
          </form>

          <div class="mt-3 mb-1">
            <routerLink :to="{name: 'Login'}">Ya tengo una cuenta</routerLink>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { required, email, minLength, maxLength, sameAs } from 'vuelidate/lib/validators';

export default {
  data() {
    return {
      nombre: '',
      email: '',
      password: '',
      passwordConfirm: '',
      loading: false,
      errorMessage: '',
      errors: []
    }
  },
  beforeCreate () {
    if (localStorage.getItem('is_loggedin')) {
      this.$router.push({name: 'Tablero'})
    }
  },
  validations: {
    nombre: {
      required
    },
    email: {
      required,
      email
    },
    password: {
      required,
      minLength: minLength(8),
      maxLength: maxLength(18)
    },
    passwordConfirm: {
      sameAs: sameAs('password')
    }
  },
  methods: {
    procesar() {
      this.loading = true
      let config = {
        headers: {
          'Accept': 'application/json'
        }
      }
      let usuario = {
        name: this.$v.nombre.$model,
        email: this.$v.email.$model,
        password: this.$v.password.$model,
        password_confirmation: this.$v.passwordConfirm.$model
      }
      this.axios.post('/auth/register', usuario, config)
        .then((res) => {
          this.loading = false
          Toast.fire({
            icon: 'success',
            title: res.data.message
          })
          this.$router.push({name: 'Login'})
        })
        .catch((e) => {
          this.loading = false
          this.errorMessage = e.response.data.message
          this.errors = e.response.data.body?.errores ?? []
          this.limpiarErrorMessage()
        })
    },
    limpiarErrorMessage () {
      setTimeout(() => {
        this.errorMessage = ''
      }, 6000);
    },
    limpiarErrores (name) {
      delete this.errors[name]
    }
  }
}
</script>
